#version 330

layout (location = 0) in vec3 inPosition;
layout (location = 1) in vec2 inCoord;
layout (location = 2) in vec3 inNormal;


uniform mat4 mv_matrix;
uniform mat4 proj_matrix;

out VS_OUT
{
  vec4 color;
} vs_out;


smooth out vec2 vTexCoord;
smooth out vec3 vNormal;
smooth out vec3 vWorldPos;
smooth out vec4 vEyeSpacePos;

void main()
{

  gl_Position = proj_matrix * vec4(inPosition,1.0);
  vs_out.color =   vec4(inPosition, 1.0) * 2.0 +   vec4(0.5,0.5,0.5,0.0);

  
  vEyeSpacePos = mv_matrix*vec4(inPosition, 1.0);
  
  vTexCoord = inCoord;
  vNormal = inNormal;
   
  vec4 vWorldPosLocal =  vec4(inPosition,1.0);
  vWorldPos = vWorldPosLocal.xyz;

}