#version 330 core


smooth in vec2 vTexCoord;
smooth in vec3 vNormal;
smooth in vec4 vEyeSpacePos;
smooth in vec3 vWorldPos;

in vec4 ShadowCoord;

out vec4 outputColor;

uniform sampler2D gSampler;
uniform vec4 vColor;
uniform int sb;

uniform sampler2DShadow shadowMap;

struct DirectionalLight
{
	vec3 vColor;
	vec3 vDirection;
	float fAmbient;
};

uniform DirectionalLight sunLight;

void main()
{

	//vColor = vec4(1.0,1.0,1.0,1.0);
	//color = fs_in.color;

	vec3 vNormalized = normalize(vNormal);
	
	vec4 vTexColor = texture2D(gSampler, vTexCoord);

	vec4 vMixedColor = vTexColor*vec4(0.5,0.5,0.5,0.5);//;vColor;
    //vec4 vDirLightColor = GetDirectionalLightColor(sunLight, vNormalized);

//	vec4 testFBO = vec4(texture(shadowMap, vec3(vTexCoord,1)),0,0,1.0);

	vec3 ct,cf;
	
	float intensity, at, af;
	intensity = max(dot(normalize(vColor.rgb), normalize(-vNormalized)),0.0);
	
	cf = (intensity * vec3(1.0, 1.0, 1.0));
	af = vTexColor.a;
	
	ct = vTexColor.rgb;
	at=vTexColor.a;

	vec4 gouraudColor = vec4(ct*cf,at);

	vec3 lookup = vec3(ShadowCoord.xy, ShadowCoord.z/ShadowCoord.w);

	float visibility = 0.5;//texture(shadowMap, lookup);
	visibility = 1.0;
	vec4 result;
	result = visibility * gouraudColor;
	
	//beim schreiben in das fbo
	vec4 lensflare = (max(vec4(0.0),vTexColor)+vec4(0.5))*5;
	if(lensflare.r<0.6 || lensflare.g<0.6)lensflare=vec4(0.0);

	//lensflare = (max(vec4(0.95), vTexColor)-0.95)*9.5;
	
	lensflare = vTexColor;

	//if(sb==0) outputColor = gouraudColor;
	if(sb==0) outputColor = result;
	else if(sb==1) outputColor=vTexColor;
	//else if(sb==1) outputColor=testFBO;
	else if(sb==2) outputColor = lensflare;
	//else if(sb==2) outputColor = vec4(1,1,0,1);
}