#version 330

layout (location = 0) in vec3 inPosition;
layout (location = 1) in vec2 inCoord;
layout (location = 2) in vec3 inNormal;


uniform mat4 mv_matrix;
uniform mat4 proj_matrix;
uniform mat4 model_matrix;
uniform mat4 normal_matrix;
uniform mat4 depthBiasMVP;

out VS_OUT
{
  vec4 color;
} vs_out;


smooth out vec3 vNormal;
smooth out vec2 vTexCoord;
smooth out vec3 vWorldPos;

smooth out vec4 vEyeSpacePos;

out vec4 ShadowCoord;

void main()
{

 // vec4 inPositionScaled = scalematrix *  vec4(inPosition, 1.0);
  gl_Position = proj_matrix * mv_matrix * model_matrix *vec4(inPosition, 1.0);
  
//  gl_Position = proj_matrix * mv_matrix * inPositionScaled;
//  vs_out.color =   vec4(inPosition, 1.0) * 2.0 +   vec4(0.5,0.5,0.5,0.0);

 vTexCoord = inCoord;

 vEyeSpacePos = proj_matrix * mv_matrix * model_matrix *vec4(inPosition, 1.0);
 
 ShadowCoord = depthBiasMVP * vec4(inPosition,1);

  //vNormal = (normal_matrix*vec4(inNormal, 1.0)).xyz;
  vNormal = inNormal;
  vWorldPos = (model_matrix*vec4(inPosition, 1.0)).xyz;

}