#version 330 core


smooth in vec2 vTexCoord;
smooth in vec3 vNormal;
smooth in vec4 vEyeSpacePos;
smooth in vec3 vWorldPos;
out vec4 outputColor;

uniform sampler2D gSampler;
uniform vec4 vColor;
uniform int sb;

struct DirectionalLight
{
	vec3 vColor;
	vec3 vDirection;
	float fAmbient;
};

uniform DirectionalLight sunLight;

void main()
{
	//vColor = vec4(1.0,1.0,1.0,1.0);
	//color = fs_in.color;

	vec3 vNormalized = normalize(vNormal);
	
	vec4 vTexColor = texture2D(gSampler, vTexCoord);

	vec4 vMixedColor = vTexColor*vec4(0.5,0.5,0.5,0.5);//;vColor;
    //vec4 vDirLightColor = GetDirectionalLightColor(sunLight, vNormalized);

	

	vec3 ct,cf;
	
	float intensity, at, af;
	intensity = max(dot(normalize(vColor.rgb), normalize(-vNormalized)),0.0);
	
	cf = (intensity * vec3(1.0, 1.0, 1.0));
	af = vTexColor.a;
	
	ct = vTexColor.rgb;
	at=vTexColor.a;

	vec4 gouraudColor = vec4(ct*cf,at);

	//if(intensity == 0) gouraudColor = vec4(1.0, 1.0, 0.0, 1.0);
	if(sb==0) outputColor = gouraudColor;
	else outputColor=vMixedColor;
	//outputColor = vec4(1.0,1.0,0,1.0);
	//outputColor=vMixedColor;
	outputColor = vec4(1.0,1.0,0,1.0);
}