#version 330

layout (location = 0) in vec3 inPosition;
layout (location = 1) in vec2 inCoord;
layout (location = 2) in vec3 inNormal;


uniform mat4 mv_matrix;
uniform mat4 proj_matrix;
uniform mat4 model_matrix;

out VS_OUT
{
  vec4 color;
} vs_out;

uniform mat4 scalematrix;
uniform int lf_flag;

smooth out vec2 vTexCoord;
smooth out vec3 vNormal;
smooth out vec3 vWorldPos;
smooth out vec4 vEyeSpacePos;


uniform mat4 depthBiasMVP;


out vec4 vPos;
out vec4 ShadowCoord;
out float islf;


void main()
{

  vec4 inPositionScaled = scalematrix *  vec4(inPosition, 1.0);
  inPositionScaled.y =  inPositionScaled.y + 45.0;
  
  if(lf_flag==0)   gl_Position = proj_matrix * mv_matrix* model_matrix* vec4(inPosition, 1.0);  
  else gl_Position = proj_matrix * mv_matrix * inPositionScaled;
  
  vs_out.color =   vec4(inPosition, 1.0) * 2.0 +   vec4(0.5,0.5,0.5,0.0);

  ShadowCoord = depthBiasMVP * vec4(inPosition,1.0);
  
  islf = lf_flag;

  vEyeSpacePos = mv_matrix*vec4(inPosition, 1.0);
  vPos = vec4(inPosition,1.0);

  vTexCoord = inCoord;
  vNormal = inNormal;
  
  vec4 vWorldPosLocal = inPositionScaled;

  vWorldPos = vWorldPosLocal.xyz;

}